# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Variable-OnDestruct
Version:	0.09
Release:	1.%{__distinit}%{__distvers}
Summary:	Don't catch exceptions from destruct handlers
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Variable-OnDestruct
Source0:	https://cpan.metacpan.org/modules/by-module/Variable/Variable-OnDestruct-%{version}.tar.gz
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(Config)
BuildRequires:	perl(Module::Build::Tiny) >= 0.036
# Module Runtime
BuildRequires:	perl(Exporter) >= 5.57
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# Test Suite
BuildRequires:	perl(Symbol)
BuildRequires:	perl(Test::More) >= 0.90
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

# Avoid provides of private shared objects
%{?perl_default_filter}

%description
This module allows you to let a function be called when a variable gets
destroyed. The destructor will work not only on scalars but also on arrays,
hashes, subs and globs. For the latter two you should realize that most of
them aren't scoped like normal variables. Subs for example will only work
like you expect them to when they are closures.

%prep
%setup -q -n Variable-OnDestruct-%{version}

%build
perl Build.PL --installdirs=vendor
./Build

%install
./Build install --destdir=%{buildroot} --create_packlist=0
%{_fixperms} -c %{buildroot}

%check
./Build test

%files
%license LICENSE
%doc Changes README
%{perl_vendorarch}/auto/Variable/
%{perl_vendorarch}/Variable/
%{_mandir}/man3/Variable::OnDestruct.3*

%changelog
* Sat Mar 30 2024 Paul Howarth <paul@city-fan.org> - 0.09-1
- Update to 0.09
  - Further fix on older perls

* Wed Mar 27 2024 Paul Howarth <paul@city-fan.org> - 0.08-1
- Update to 0.08
  - Revert not catching exceptions from destruct handlers
  - Restore functionality on perl ≤ 5.12

* Wed Feb 28 2024 Paul Howarth <paul@city-fan.org> - 0.07-1
- Initial RPM version

